// JGameEx27.java

import ch.aplu.jgamegrid.*;
import java.awt.*;
import java.awt.event.KeyEvent;


public class JGameEx27 extends GameGrid implements GGActorCollisionListener
{
  private final int countMax = 10;
  private int count = countMax;
  private Clownfish1 nemo = new Clownfish1();
  private final Location startLocation = new Location(50, 300);

  public JGameEx27()
  {
    super(600, 600, 1, null, false);
    setSimulationPeriod(100);
    addActor(nemo, startLocation);
    addKeyListener(nemo);
    nemo.addActorCollisionListener(this);
    nemo.setCollisionCircle(new Point(0, 0), 40);
    for (int i = 0; i < 10; i++)
      createJellyfish();
    show();
    doRun();
  }

  public int collide(Actor actor1, Actor actor2)
  {
    nemo.setLocation(startLocation);
    return 0;
  }

  private void createJellyfish()
  {
    int x = 500 + (int)(400 * Math.random());
    int y = (int)(600 * Math.random());
    Jellyfish jelly  = new Jellyfish();
    addActor(jelly, new Location(x, y), -180);
    nemo.addCollisionActor(jelly);
  }

  public void act()
  {
    count--;
    if (count == 0)
    {
       createJellyfish();
       count = countMax;
    }
  }

  public static void main(String[] args)
  {
    new JGameEx27();
  }
}

// ---------------------   class Clowfish1 --------------------------------
class Clownfish1 extends Actor implements GGKeyListener
{
  private int id = 0;

  public Clownfish1()
  {
    super("sprites/nemo.gif", 2);
  }

  public boolean keyPressed(KeyEvent evt)
  {
    switch (evt.getKeyCode())
    {
      case KeyEvent.VK_UP:
        setLocation(new Location(getLocation().x, getLocation().y - 5));
        break;
      case KeyEvent.VK_DOWN:
        setLocation(new Location(getLocation().x, getLocation().y + 5));
        break;
      case KeyEvent.VK_LEFT:
        setLocation(new Location(getLocation().x - 5, getLocation().y));
        break;
      case KeyEvent.VK_RIGHT:
        setLocation(new Location(getLocation().x + 5, getLocation().y));
        break;
    }
    return false;  // Don't consume
  }

  public void act()
  {
    if (getLocation().x > 500)
      showNextSprite();
  }

  public boolean keyReleased(KeyEvent evt)
  {
    return false;
  }
}

// ------------------------ class Jellyfish -----------------------------------

class Jellyfish extends Actor
{
  public Jellyfish()
  {
    super("sprites/jellyfish.gif");
  }

  public void act()
  {
    move();
    if (getLocation().x < - 10)
      removeSelf();
  }
}

